/*******************\
*  Efsane 0.5.1     *
*  Kisayol Modulu   *
\*******************/

#include <X11/Xlib.h>
#include <stdlib.h>

#include "turkpy.h"

TurkPY_Kisayol::init(char *bas1,char *bas2,char *bas3,int sira)
{
 Pixmap pix1;
 baslik=(char *)malloc(strlen(bas1)+1);
 calis_baslik=(char *)malloc(strlen(bas2)+1);
 strcpy(baslik,bas1);
 strcpy(calis_baslik,bas2);
 turkpy.durdur();
 handle=XCreateSimpleWindow(dpy,kok_pencere,0,0,ikon_boyu,ikon_boyu,0,beyaz,siyah);
 XSelectInput(dpy,handle,ExposureMask | ButtonReleaseMask);
 XReparentWindow(dpy,handle,turkpy.ana_pencere.handle,turkpy.ana_pencere.ozellik_pencere.width-ikon_boyu,
    sira*ikon_boyu);
 XGetWindowAttributes(dpy,handle,&ozellik_pencere);
 XSetWindowBackgroundPixmap(dpy,handle,turkpy.kisayol_arka_plan);
 XMapWindow(dpy,handle);
 xpmatt.valuemask=0;
 if (XpmReadPixmapFile(dpy,handle,bas3,&ikon,&pix1,&xpmatt)!=XpmSuccess)
 {
  ikon=ikon_resim;
  xpmatt.width=40;
  xpmatt.height=30;
 }
 gecici1.font=stdfnt->fid;
 gc_pencere=XCreateGC(dpy,handle,GCFont,&gecici1);
 if (xpmatt.width>ikon_boyu-10)
  xpmatt.width=ikon_boyu-10;
 if (xpmatt.height>ikon_boyu-25)
  xpmatt.height=ikon_boyu-25;
 turkpy.harekete_gec();
 isim_uzun=XTextWidth(stdfnt,baslik,strlen(baslik));
 if (isim_uzun>ikon_boyu)
  isim_uzun=ikon_boyu;
 XFlush(dpy);
}

TurkPY_Kisayol::paint(void)
{
 XClearWindow(dpy,handle);
 if (ikon)
  XCopyArea(dpy,ikon,handle,gc_pencere,0,0,xpmatt.width,xpmatt.height,(ikon_boyu-xpmatt.width)/2,5);
 if (baslik[0])
 {
  XSetForeground(dpy,gc_pencere,beyaz);
  XDrawString(dpy,handle,gc_pencere,(ikon_boyu-isim_uzun)/2,ikon_boyu-5,baslik,strlen(baslik));
 }
}

void TurkPY_Kisayol::tusa_bas(Time zaman)
{
 if (!son_bas)
  son_bas=zaman;
 else
 {
  if (zaman-son_bas>turkpy.cift_klik)
   son_bas=zaman;
  else
   prog_calis(calis_baslik);
 }
}

