/*****************\
*  Efsane 0.5.11  *
*  Ana Modul      *
\*****************/

#include <X11/Xlib.h>
#include <stdio.h>
#include <stdlib.h>

#include "turkpy.h"

int siyah,beyaz;
Display *dpy;
pencere_liste_tipi *sonraki,*gecici;
TurkPY turkpy;

void hata(int hatano)
{
 fprintf(stderr,"%d   Hata: ",hatano+900);
 switch (hatano)
 {
  case 1:
   fprintf(stderr,"X oturumu acilamiyor...\n");
   exit(hatano);
  case 2:
   fprintf(stderr,"X oturumunda bilinmeyen bir hata olustu...\n");
   break;
  default:
   fprintf(stderr,"Tanimlanamayan sorun...\n");
   exit(hatano);
 }
}

static int hata_kontrol(Display *dpy,XErrorEvent *olay)
{
 hata(2);
 return False;
}

void hafiza_bosalt()
{
 gecici=pencere_listesi;
 do
 {
  sonraki=gecici;
  gecici=gecici->sonraki;
  free(sonraki);
 }
 while (gecici!=NULL);
 XCloseDisplay(dpy);
}

main()
{
 XSetErrorHandler((XErrorHandler) hata_kontrol);
 // Goruntuyu ac
 dpy=XOpenDisplay(NULL);
 if (!dpy) hata(1);
 // Renkleri al
 siyah=BlackPixel(dpy,scr);
 beyaz=WhitePixel(dpy,scr);
 // Ana modulu baslat
 boyama_init();
 turkpy.init();
 turkpy.donguye_gir();
 hafiza_bosalt();
 return 0;
}

