/***********************\
*  Efsane 0.6.0         *
*  Menu Modulu          *
*  Baslik (.h) Dosyasi  *
\***********************/

#include <X11/Xlib.h>
#include <sys/cdefs.h>

#ifdef __PMT
typedef int (*tusa_bas_fonk) __PMT ((char *baslik,Window handle));
#else
typedef int (*tusa_bas_fonk) __P ((char *baslik,Window handle));
#endif

class TurkPY_Menu_Komutu
{
public:
       Window handle,baba;
       TurkPY_Menu_Komutu *sonraki;
       int wid;
       Pixmap arka_plan1,arka_plan2;
       GC gc_pencere;
       Bool uzerinde,mapped,otomatik;
       tusa_bas_fonk tusa_bas;
       char baslik[255],calis_baslik[255];
       init(int,int);
       paint(void);
       void durum_degis(Bool);
};

class TurkPY_Menu
{
public:
       Window handle,ust_menu;
       TurkPY_Menu_Komutu *ilk_komut;
       Bool menu_ekranda;
       char menu_adi[80];
       Pixmap menu_arka_plan1,menu_arka_plan2;
       int x,w,y;
       init(int,int);
       void komut_ekle(char *,char *,tusa_bas_fonk);
       void sonlandir(void);
};

int menu_kapat(char *,Window);
void menu_kapat2(TurkPY_Menu *);
int alt_menu(char *,Window);

