/****************\
*  Efsane 0.6.0  *
*  Tus Modulu    *
\****************/

#include <X11/Xlib.h>

#include "turkpy.h"

TurkPY_Tus::init(int x,int y,int tip,Window hand)
{
 TurkPY_Pencere *wind;
 handle=XCreateSimpleWindow(dpy,kok_pencere,x,y,tus_boyu,tus_boyu,0,beyaz,siyah);
 XGetWindowAttributes(dpy,handle,&ozellik_tus);
 XSelectInput(dpy,handle,StructureNotifyMask | ExposureMask | ButtonMotionMask |
    ButtonPressMask | ButtonReleaseMask | PointerMotionMask);
 gc_tus=XCreateGC(dpy,handle,0,NULL);
 XReparentWindow(dpy,handle,hand,x,y);
 wind=turkpy.pencere_bul(hand);
 if (wind!=NULL)
  wind->tuslar[tip-1]=handle;
 tus_tipi=tip;
 XSetWindowBackgroundPixmap(dpy,handle,turkpy.tus_arka_plan1);
 XMapWindow(dpy,handle);
 XFlush(dpy);
}

TurkPY_Tus::paint(void)
{
 XSetForeground(dpy,gc_tus,beyaz);
 switch (tus_tipi)
 {
  case 1:
  {
   XDrawLine(dpy,handle,gc_tus,7,10,2,15);
   XDrawLine(dpy,handle,gc_tus,2,15,2,13);
   XDrawLine(dpy,handle,gc_tus,2,15,4,15);
   XDrawRectangle(dpy,handle,gc_tus,9,2,6,6);
   break;
  }
  case 2:
  {
   XDrawLine(dpy,handle,gc_tus,2,2,15,15);
   XDrawLine(dpy,handle,gc_tus,15,2,2,15);
   XDrawRectangle(dpy,handle,gc_tus,5,5,7,7);
   break;
  }
  case 3:
  {
   XDrawLine(dpy,handle,gc_tus,9,2,9,9);
   XDrawLine(dpy,handle,gc_tus,9,9,7,7);
   XDrawLine(dpy,handle,gc_tus,9,9,11,7);
   XDrawRectangle(dpy,handle,gc_tus,2,11,13,4);
   break;
  }
  case 4:
  {
   XDrawLine(dpy,handle,gc_tus,9,4,9,11);
   XDrawLine(dpy,handle,gc_tus,9,4,7,6);
   XDrawLine(dpy,handle,gc_tus,9,4,11,6);
   XDrawRectangle(dpy,handle,gc_tus,2,2,13,13);
   break;
  }
  case 5:
  {
   XDrawLine(dpy,handle,gc_tus,3,5,14,5);
   XDrawLine(dpy,handle,gc_tus,3,8,14,8);
   XDrawLine(dpy,handle,gc_tus,3,11,14,11);
   XDrawRectangle(dpy,handle,gc_tus,2,2,12,12);
   break;
  }
 }
 XFlush(dpy);
}

void TurkPY_Tus::tusa_bas(int tip)
{
 TurkPY_Pencere *wind;
 int w,h;
 XEvent olay2;
 wind=turkpy.pencere_bul_parent(handle);
 if (wind!=NULL)
 {
  switch (tus_tipi)
  {
   case 1:
   {
    if (tip==1)
    {
     wind->maxed=False;
     boyutlandir=True;
     XDefineCursor(dpy,wind->handle,turkpy.buyukluk_kursor);
    }
    else
    if (tip==2)
    {
     boyutlandir=False;
     XDefineCursor(dpy,wind->handle,turkpy.normal_kursor);
     turkpy.pencere_boyut(wind,wind->ozellik_pencere.x,wind->ozellik_pencere.y,
        wind->ozellik_pencere.width,wind->ozellik_pencere.height,True);
    }
    break;
   }
   case 2:
   {
    if (tip==2)
    {
     turkpy.durdur();
     if (wind->menu.menu_ekranda)
      menu_kapat("",wind->menu.handle);
     if (!turkpy.kontrol_et(wind->alt_kisim,True)) return;
     olay2.xclient.type=ClientMessage;
     olay2.xclient.message_type=atom_protokol;
     olay2.xclient.display=dpy;
     olay2.xclient.window=wind->alt_kisim;
     olay2.xclient.format=32;
     olay2.xclient.data.l[0]=atom_yok_et;
     olay2.xclient.data.l[1]=CurrentTime;
     olay2.xclient.data.l[2]=0l;
     olay2.xclient.data.l[3]=0l;
     olay2.xclient.data.l[4]=0l;
     XSendEvent(dpy,wind->alt_kisim,False,NoEventMask,&olay2);
     turkpy.harekete_gec();
    }
    break;
   }
   case 3:
   {
    if (tip==2)
    {
     turkpy.ikon_yarat(wind->handle);
    }
    break;
   }
   case 4:
   {
    if (tip==2)
    {
     if (wind->maxed)
     {
      wind->maxed=False;
      turkpy.pencere_boyut(wind,wind->eskix,wind->eskiy,wind->eskiw,wind->eskih,True);
      eXRaiseWindow(dpy,wind);
     }
     else
     {
      wind->maxed=True;
      if (wind->maxsize)
      {
       if (ozellik_kok_pencere.width>wind->maxw)
        w=wind->maxw;
       else
        w=ozellik_kok_pencere.width;
       if (ozellik_kok_pencere.height>wind->maxh)
        h=wind->maxh;
       else
        h=ozellik_kok_pencere.height;
       turkpy.pencere_boyut(wind,0,0,w,h,True);
      }
      else
       turkpy.pencere_boyut(wind,0,0,ozellik_kok_pencere.width,ozellik_kok_pencere.height,True);
      eXRaiseWindow(dpy,wind);
     }
    }
    break;
   }
   case 5:
   {
    if (tip==2)
     wind->menu.init(ozellik_tus.x+wind->ozellik_pencere.x,
        ozellik_tus.y+ozellik_tus.height+wind->ozellik_pencere.y);
    break;
   }
  }
 }
}

