/**************************************\
* Efsane 0.6.0                         *
* ~/.efsane.ayarlar Yaratma Uygulamasi *
\**************************************/

#define surum "0.6.0.beta"

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xresource.h>

int menu_boyut_h,cift_klik,apt,ppt,mut,uzaktan_durum;
int apr[2][3],ppr[2][3],mur[2][3],say1,say2,bilgi_goster;
char uzaktan_sifre[80],dosya_adi[255],*deger_tipi,veri_adi[255];
char apd_isim[160],ppd_isim[160],mud_isim[160],dil_isim[30];
XrmDatabase veriler;
XrmValue deger_veri;

void verileri_yukle(void)
{
 // Veri tabani icin standart ayarlari yukle...
 apt=
 apr[0][0]=apr[0][1]=
 apr[1][0]=apr[1][1]=apr[1][2]=0;
 apr[0][2]=255;
 ppt=
 ppr[1][0]=ppr[1][1]=ppr[1][2]=0;
 ppr[0][0]=ppr[0][1]=ppr[0][2]=127;
 mur[0][0]=mur[0][1]=
 mur[1][0]=mur[1][1]=mur[1][2]=0;
 mut=1;
 mur[0][2]=255;
 cift_klik=250;
 menu_boyut_h=16;
 uzaktan_durum=0;
 bilgi_goster=1;
 strcpy(uzaktan_sifre,"efsane");
 strcpy(dil_isim,"English");
 apd_isim[0]=ppd_isim[0]=mud_isim[0]=0;
 // Veri tabanini baslat...
 XrmInitialize();
 // Dosyayi ac...
 sprintf(dosya_adi,"%s/.efsane.ayarlar",getenv("HOME"));
 if ((veriler=XrmGetFileDatabase(dosya_adi))!=NULL)
 {
  XrmGetResource(veriler,"efsane.surum","efsane.surum",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   if (!strcmp(deger_veri.addr,surum))
   {
    XrmDestroyDatabase(veriler);
    exit(0);
   }
  // Bilgi tipini al...
  XrmGetResource(veriler,"efsane.dil","efsane.dil",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&dil_isim);
  // Bilgi tipini al...
  XrmGetResource(veriler,"bilgi.goster","bilgi.goster",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&bilgi_goster);
  // Menu boyutunu al...
  XrmGetResource(veriler,"menu.yukseklik","menu.yukseklik",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&menu_boyut_h);
  // Cift klikleme suresini al...
  XrmGetResource(veriler,"cift","cift",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&cift_klik);
  // Aktif Pencere boyama Tipini al...
  XrmGetResource(veriler,"apt","apt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&apt);
  // Pasif Pencere boyama Tipini al...
  XrmGetResource(veriler,"ppt","ppt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&ppt);
  // Masa Ustu boyama Tipini al...
  XrmGetResource(veriler,"mut","mut",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&mut);
  // Aktif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"apd.isim","apd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&apd_isim);
  // Pasif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"ppd.isim","ppd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&ppd_isim);
  // Masa Ustu boyama Dosya Ismini al...
  XrmGetResource(veriler,"mud.isim","mud.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&mud_isim);
  // Uzaktan Kumanda durumunu al...
  XrmGetResource(veriler,"uzaktan.durum","uzaktan.durum",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&uzaktan_durum);
  // Uzaktan Kumanda sifresini al...
  XrmGetResource(veriler,"uzaktan.sifre","uzaktan.sifre",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",uzaktan_sifre);
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
   {
    // Aktif Pencere boyama Rengini al...
    sprintf(veri_adi,"apr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&apr[say1][say2]);
    // Pasif Pencere boyama Rengini al...
    sprintf(veri_adi,"ppr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&ppr[say1][say2]);
    // Masa Ustu boyama Rengini al...
    sprintf(veri_adi,"mur%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&mur[say1][say2]);
   }
  // Veri tabanini kapat...
  XrmDestroyDatabase(veriler);
 }
}

void verileri_kaydet(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.ayarlar",getenv("HOME"));
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"efsane.surum : %s\n",surum);
 fprintf(dosya,"efsane.dil : %s\n",dil_isim);
 fprintf(dosya,"menu.yukseklik : %d\n",menu_boyut_h);
 fprintf(dosya,"bilgi.goster : %d\n",bilgi_goster);
 fprintf(dosya,"cift : %d\n",cift_klik);
 fprintf(dosya,"apt : %d\n",apt);
 fprintf(dosya,"ppt : %d\n",ppt);
 fprintf(dosya,"mut : %d\n",mut);
 fprintf(dosya,"apd.isim : %s\n",apd_isim);
 fprintf(dosya,"ppd.isim : %s\n",ppd_isim);
 fprintf(dosya,"mud.isim : %s\n",mud_isim);
 fprintf(dosya,"uzaktan.durum : %d\n",uzaktan_durum);
 fprintf(dosya,"uzaktan.sifre : %s\n",uzaktan_sifre);
 for (say1=0;say1<2;say1++)
  for (say2=0;say2<3;say2++)
  {
   fprintf(dosya,"apr%d%d : %d\n",say1,say2,apr[say1][say2]);
   fprintf(dosya,"ppr%d%d : %d\n",say1,say2,ppr[say1][say2]);
   fprintf(dosya,"mur%d%d : %d\n",say1,say2,mur[say1][say2]);
  }
 fclose(dosya);
}

void kisayol_kaydet(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.kisayol",getenv("HOME"));
 dosya=fopen(dosya_adi,"r");
 if (dosya!=NULL)
 {
  fclose(dosya);
  return;
 }
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"Netscape,netscape,/usr/share/pixmaps/Netscape.xpm\n");
 fprintf(dosya,"Terminal,rxvt -ls -bg black -fg white -fn fixed,/usr/share/pixmaps/kterm.xpm\n");
 fprintf(dosya,"}\n");
 fclose(dosya);
}

void dil_kaydet_turkce(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.dil.Turkce",getenv("HOME"));
 dosya=fopen(dosya_adi,"r");
 if (dosya!=NULL)
 {
  fclose(dosya);
  return;
 }
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"OTURUM_KAPAT : Oturumu Kapat\n");
 fprintf(dosya,"MENU_KAPAT : Menuyu Kapat\n");
 fprintf(dosya,"UYGULAMALAR : Uygulamalar\n");
 fprintf(dosya,"PENC_SHOW : Pencereyi Goster\n");
 fprintf(dosya,"PENC_KAPAT : Pencereyi Kapat\n");
 fprintf(dosya,"PENC_OLDUR : Pencereyi Oldur\n");
 fprintf(dosya,"PENC_MAX : Ekrani Kaplat\n");
 fprintf(dosya,"PENC_MIN : Pencereyi Kucult\n");
 fprintf(dosya,"IKON_DIZ : Ikonlari Diz\n");
 fprintf(dosya,"EN : En\n");
 fprintf(dosya,"BOY : Boy\n");
 fprintf(dosya,"AUTHOR : Serdar Ozler\n");
 fclose(dosya);
}

void dil_kaydet_english(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.dil.English",getenv("HOME"));
 dosya=fopen(dosya_adi,"r");
 if (dosya!=NULL)
 {
  fclose(dosya);
  return;
 }
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"OTURUM_KAPAT : Shut Down\n");
 fprintf(dosya,"MENU_KAPAT : Close Menu\n");
 fprintf(dosya,"UYGULAMALAR : Applications\n");
 fprintf(dosya,"PENC_SHOW : Show Window\n");
 fprintf(dosya,"PENC_KAPAT : Close Window\n");
 fprintf(dosya,"PENC_OLDUR : Kill Window\n");
 fprintf(dosya,"PENC_MAX : Maximize Window\n");
 fprintf(dosya,"PENC_MIN : Minimize Window\n");
 fprintf(dosya,"IKON_DIZ : Arrange Icons\n");
 fprintf(dosya,"EN : Width\n");
 fprintf(dosya,"BOY : Height\n");
 fprintf(dosya,"AUTHOR : Serdar Ozler\n");
 fclose(dosya);
}

void dil_kaydet_deutsch(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.dil.Deutsch",getenv("HOME"));
 dosya=fopen(dosya_adi,"r");
 if (dosya!=NULL)
 {
  fclose(dosya);
  return;
 }
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"OTURUM_KAPAT : Sitzung Beenden\n");
 fprintf(dosya,"MENU_KAPAT : Menue Schliessen\n");
 fprintf(dosya,"UYGULAMALAR : Anwendungen\n");
 fprintf(dosya,"PENC_SHOW : Zeige Fenster\n");
 fprintf(dosya,"PENC_KAPAT : Beende Fenster\n");
 fprintf(dosya,"PENC_OLDUR : Schliesse Fenster\n");
 fprintf(dosya,"PENC_MAX : Fenster Maximieren\n");
 fprintf(dosya,"PENC_MIN : Fenster Minimieren\n");
 fprintf(dosya,"IKON_DIZ : Symbole Anordnen\n");
 fprintf(dosya,"EN : Breite\n");
 fprintf(dosya,"BOY : Hoehe\n");
 fprintf(dosya,"AUTHOR : Levent Sarikaya\n");
 fclose(dosya);
}

void menu_kaydet(void)
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.menu",getenv("HOME"));
 dosya=fopen(dosya_adi,"r");
 if (dosya!=NULL)
 {
  fclose(dosya);
  return;
 }
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"Efsane.Menu,{\n");
 fprintf(dosya," Araclar/Tools,{\n");
 fprintf(dosya,"  Clipboard,xclipboard\n");
 fprintf(dosya,"  Manual Browser,xman\n");
 fprintf(dosya,"  TkDesk,tkdesk\n");
 fprintf(dosya," }\n");
 fprintf(dosya," Grafik/Graphic,{\n");
 fprintf(dosya,"  Gimp,gimp\n");
 fprintf(dosya,"  XPaint,xpaint\n");
 fprintf(dosya,"  XV,xv\n");
 fprintf(dosya," }\n");
 fprintf(dosya," Internet,{\n");
 fprintf(dosya,"  Netscape Navigator,netscape\n");
 fprintf(dosya,"  X-ISP,xisp\n");
 fprintf(dosya," }\n");
 fprintf(dosya," Muzik/Music,{\n");
 fprintf(dosya,"  X11Amp,x11amp\n");
 fprintf(dosya," }\n");
 fprintf(dosya," Terminal,{\n");
 fprintf(dosya,"  Rxvt,rxvt -ls -bg black -fg white -fn fixed\n");
 fprintf(dosya,"  XTerm,xterm -sb\n");
 fprintf(dosya," }\n");
 fprintf(dosya,"}\n");
 fclose(dosya);
}

int main(void)
{
 verileri_yukle();
 verileri_kaydet();
 menu_kaydet();
 kisayol_kaydet();
 dil_kaydet_turkce();
 dil_kaydet_english();
 dil_kaydet_deutsch();
 printf("       Efsane %s Ayar Modulu\n",surum);
 printf("       ~/.efsane.* basariyla hazirlandi...\n");
 return 0;
}
