/***************************\
*  Efsane Yoneticisi 0.6.0  *
*  Sistem Modulu            *
\***************************/

#include <qapplication.h>
#include <qkeycode.h>
#include <qlabel.h>
#include <qfont.h>
#include <qfiledialog.h>

#include <X11/Xlib.h>
#include <X11/Xresource.h>

#include <stdio.h>
#include <stdlib.h>

#include "yonetici.h"

#define aralik 10
#define surum "0.6.0.beta"

int menu_boyut_h,cift_klik,apt,ppt,mut,uzaktan_durum;
int apr[2][3],ppr[2][3],mur[2][3],say1,say2,bilgi_goster;
char uzaktan_sifre[80],dosya_adi[255],*deger_tipi,veri_adi[255];
char apd_isim[160],ppd_isim[160],mud_isim[160],dil_isim[30];
char dil_yazi[3][8]={"Turkce","English","Deutsch"};

AnaPencere::AnaPencere() : QMainWindow(0,"")
{
 QFontMetrics fm(fontMetrics());
 int y=10,texth=fm.height(),temp,say1,say2;

 char anatab_yazi[sayfa_say][9]={"Genel","Renkler","Hakkinda"};
 sayf=new QTabBar(this,"sayfalar");
 for (say1=0;say1<sayfa_say;say1++)
 {
  sayfaxf[say1]=new QFrame(this,"",0,TRUE);
  sayfaxf[say1]->setGeometry(0,texth+11,500,450-texth-11);
  if (say1>0)
   sayfaxf[say1]->hide;
  sayfax[say1]=new QTab();
  sayfax[say1]->label.setStr(anatab_yazi[say1]);
  sayf->addTab(sayfax[say1]);
 }
 sayf->setGeometry(0,0,320,texth+10);
 connect(sayf,SIGNAL(selected(int)),SLOT(SayfaDegis(int)));

 QLabel *yazi_menuyukseklik=new QLabel("Menu Yuksekligi :",sayfaxf[0],"");
 yazi_menuyukseklik->setGeometry(10,y+5,say1=fm.width(yazi_menuyukseklik->text()),texth);
 edit_menuyukseklik=new QSpinBox(10,100,1,sayfaxf[0],"edit_menuyukseklik");

 QLabel *yazi_cift=new QLabel("Cift Tiklama Suresi :",sayfaxf[0],"");
 edit_cift=new QSpinBox(100,1000,50,sayfaxf[0],"edit_cift");

 temp=fm.width(yazi_cift->text());
 edit_menuyukseklik->setGeometry(20+say1,y,75+temp-say1,texth+10);
 y+=texth+10+aralik;
 yazi_cift->setGeometry(10,y+5,temp,texth);
 edit_cift->setGeometry(20+temp,y,75,texth+10);
 edit_cift->setSuffix(" ms");
 y+=texth+10+aralik;

 edit_bilgidurum=new QCheckBox(sayfaxf[0],"edit_bilgidurum");
 edit_bilgidurum->setText("Efsane surumunu goster.");
 edit_bilgidurum->setGeometry(10,y,50+fm.width(edit_bilgidurum->text()),texth+10);
 y+=texth+10+aralik; 
 
 edit_uzakdurum=new QCheckBox(sayfaxf[0],"edit_uzakdurum");
 edit_uzakdurum->setText("Uzaktan Kumanda (U.K.)");
 edit_uzakdurum->setGeometry(10,y,50+fm.width(edit_uzakdurum->text()),texth+10);
 y+=texth+10+aralik; 
 
 QLabel *yazi_uzaksifre=new QLabel("U.K. Giris Sifresi :",sayfaxf[0],"");
 yazi_uzaksifre->setGeometry(10,y+5,temp=fm.width(yazi_uzaksifre->text()),texth);
 edit_uzaksifre=new QLineEdit(sayfaxf[0],"edit_uzaksifre");
 edit_uzaksifre->setGeometry(20+temp,y,edit_cift->x()+edit_cift->width()-20-temp,texth+10);
 edit_uzaksifre->setEnabled(FALSE);
 connect(edit_uzakdurum,SIGNAL(toggled(bool)),edit_uzaksifre,SLOT(setEnabled(bool)));
 y+=texth+10+aralik;

 QLabel *yazi_dilsec=new QLabel("Dil :",sayfaxf[0],"");
 yazi_dilsec->setGeometry(10,y+5,temp=fm.width(yazi_dilsec->text()),texth);
 edit_dilsec=new QComboBox(sayfaxf[0],"edit_dilsec");
 edit_dilsec->setGeometry(20+temp,y,edit_cift->x()+edit_cift->width()-20-temp,texth+10);
 for (say1=0;say1<3;say1++)
  edit_dilsec->insertItem(dil_yazi[say1]);
// y+=texth+10+aralik;

 sayfa2s=new QTabBar(sayfaxf[1],"sayfalarB");
 char sayfa_yazi[3][14]={"Aktif Pencere","Pasif Pencere","Masa Ustu"};
 for (say1=0;say1<3;say1++)
 {
  sayfa2x[say1]=new QTab(); 
  sayfa2x[say1]->label.setStr(sayfa_yazi[say1]);
  sayfa2s->addTab(sayfa2x[say1]);
 }
 sayfa2s->setGeometry(5,5,315,texth+10);
 connect(sayfa2s,SIGNAL(selected(int)),SLOT(SayfaDegis2(int)));
 y=texth+25;
 
 sec_renktipi=new QButtonGroup(sayfaxf[1],"sec_renktipi");
 sec_renktipi->setTitle("Boyama Tipi");
 char tip_yazi[3][10]={"Duz","Tonlamali","Resimli"};
 temp=50+fm.width(tip_yazi[1]);
 connect(sec_renktipi,SIGNAL(clicked(int)),SLOT(TipDegis(int)));
 
 for (say1=0;say1<3;say1++)
 {
  tus_renktipi[say1]=new QRadioButton(sec_renktipi,"");
  tus_renktipi[say1]->setText(tip_yazi[say1]);
  tus_renktipi[say1]->setGeometry(5,(10+texth)*(say1+1)-5,temp,texth+5);
 }
  
 for (say1=0;say1<2;say1++)
  sec_renk[say1]=new QGroupBox(sayfaxf[1],"");
 sec_renk[0]->setTitle("Baslangic Rengi");
 sec_renk[1]->setTitle("Bitis Rengi");

 QLabel *(renkler_yaz[2][3]);
 char renk_yazi[3][8]={"Kirmizi","Yesil","Mavi"};
 temp=fm.width(renk_yazi[0]);
 for (say2=0;say2<2;say2++)
 {
  for (say1=0;say1<3;say1++)
  { 
   renkler_yaz[say2][say1]=new QLabel(renk_yazi[say1],sec_renk[say2],"");
   renkler_yaz[say2][say1]->setGeometry(10,(15+texth)*(say1+1),temp,texth);
   renkler[say2][say1]=new QSpinBox(0,255,1,sec_renk[say2],"");
   renkler[say2][say1]->setGeometry(30+temp,(15+texth)*(say1+1)-5,50,texth+10);
   connect(renkler[say2][say1],SIGNAL(valueChanged(int)),SLOT(RenkDegis(int)));
   renkf[say2][say1]=new BoyaKutu(sec_renk[say2],0);
   renkf[say2][say1]->setGeometry(100+temp,(15+texth)*(say1+1)-5,50,texth+10);
  }
  renkf[say2][3]=new BoyaKutu(sec_renk[say2],0);
  renkf[say2][3]->setGeometry(170+temp,10+texth,texth+10,40+texth*3);
  if (say2==0)
  {
   sec_renktipi->setGeometry(15,y,195+temp+texth,texth*4+35);
   y+=texth*4+35+aralik;
  }
  sec_renk[say2]->setGeometry(15,y,195+temp+texth,texth*4+65);
  y+=texth*4+65+aralik;
 }

 QLabel *yazi_boyadosya=new QLabel("Dosya Ismi :",sayfaxf[1],"");
 yazi_boyadosya->setGeometry(15,y+5,temp=fm.width(yazi_boyadosya->text()),texth);
 edit_boyadosya=new QLineEdit(sayfaxf[1],"edit_boyadosya");
 tus_boyadosya=new QPushButton(sayfaxf[1],"tus_boyadosya");
 tus_boyadosya->setText("...");
 edit_boyadosya->setGeometry(25+temp,y,say2=sec_renktipi->width()-temp-25-fm.width(tus_boyadosya->text()),texth+10);
 tus_boyadosya->setGeometry(30+temp+say2,y,fm.width(tus_boyadosya->text())+10,texth+10);
 edit_boyadosya->setEnabled(FALSE);
 tus_boyadosya->setEnabled(FALSE);
 connect(tus_boyadosya,SIGNAL(clicked()),SLOT(DosyaSec()));
 y+=texth+10+aralik;

 sonf=new BoyaKutu(sayfaxf[1],0);
 sonf->setGeometry(sec_renktipi->width()+25,texth+25,texth*5+50,y-texth-25-aralik);
 sonf->setTip(0);
 connect(edit_boyadosya,SIGNAL(textChanged(const char *)),sonf,SLOT(setStr(const char *)));

 QGroupBox *hakkinda1=new QGroupBox(sayfaxf[2],"");
 QLabel *hakkinda2=new QLabel(hakkinda1,"");
 hakkinda2->setAlignment(AlignCenter);
 hakkinda2->setText("Efsane Yoneticisi\nSurum 0.6.0 Beta\n\nSerdar Ozler, 1999\n\nBu program Efsane'nin ayarlarini yapmak icin tasarlanmistir.\nTum haklari yazara aittir.\nPara ile satilmaz.\n\nEfsane - Serdar Ozler, 1998-1999");
 hakkinda1->setGeometry(10,50,sayfaxf[2]->width()-20,texth*13);
 hakkinda2->setGeometry(10,10,hakkinda1->width()-20,hakkinda1->height()-20);

 char tuslar_yazi[tuslar_say][7]={"Cikis","Kaydet"};
 for (say1=0;say1<tuslar_say;say1++)
 {
  tuslar[say1]=new QPushButton(this,"");
  tuslar[say1]->setText(tuslar_yazi[say1]);
  tuslar[say1]->setGeometry(sonf->x()+sonf->width()+aralik*2,450-(say1+1)*(aralik+25),100,25);
 }
 connect(tuslar[0],SIGNAL(clicked()),qApp,SLOT(quit()));
 connect(tuslar[1],SIGNAL(clicked()),SLOT(verileri_kaydet()));
 
 verileri_yukle();
 verileri_goruntule();
}

void AnaPencere::verileri_kaydet()
{
 FILE *dosya;
 sprintf(dosya_adi,"%s/.efsane.ayarlar",getenv("HOME"));
 dosya=fopen(dosya_adi,"w");
 fprintf(dosya,"efsane.surum : %s\n",surum);
 fprintf(dosya,"efsane.dil : %s\n",dil_yazi[edit_dilsec->currentItem()]);
 fprintf(dosya,"menu.yukseklik : %d\n",edit_menuyukseklik->value());
 bilgi_goster=edit_bilgidurum->isChecked() ? 1 : 0;
 fprintf(dosya,"bilgi.goster : %d\n",bilgi_goster);
 fprintf(dosya,"cift : %d\n",edit_cift->value());
 fprintf(dosya,"apt : %d\n",apt);
 fprintf(dosya,"ppt : %d\n",ppt);
 fprintf(dosya,"mut : %d\n",mut);
 fprintf(dosya,"apd.isim : %s\n",apd_isim);
 fprintf(dosya,"ppd.isim : %s\n",ppd_isim);
 fprintf(dosya,"mud.isim : %s\n",mud_isim);
 uzaktan_durum=edit_uzakdurum->isChecked() ? 1 : 0;
 fprintf(dosya,"uzaktan.durum : %d\n",uzaktan_durum);
 fprintf(dosya,"uzaktan.sifre : %s\n",edit_uzaksifre->text());
 for (say1=0;say1<2;say1++)
  for (say2=0;say2<3;say2++)
  {
   fprintf(dosya,"apr%d%d : %d\n",say1,say2,apr[say1][say2]);
   fprintf(dosya,"ppr%d%d : %d\n",say1,say2,ppr[say1][say2]);
   fprintf(dosya,"mur%d%d : %d\n",say1,say2,mur[say1][say2]);
  }
 fclose(dosya);
}

void AnaPencere::DosyaSec(void)
{
 QString isim=QFileDialog::getOpenFileName(0,"*.xpm",this,"");
 if (!(isim.isEmpty()))
  edit_boyadosya->setText(isim);
 if (sayfa2s->currentTab()==sayfa2x[0]->id)
  strcpy(apd_isim,isim);
 if (sayfa2s->currentTab()==sayfa2x[1]->id)
  strcpy(ppd_isim,isim);
 if (sayfa2s->currentTab()==sayfa2x[2]->id)
  strcpy(mud_isim,isim);
}

void AnaPencere::TipDegis(int tip)
{
 if (tip==2)
 {
  edit_boyadosya->setEnabled(TRUE);
  tus_boyadosya->setEnabled(TRUE);
 }
 else
 {
  edit_boyadosya->setEnabled(FALSE);
  tus_boyadosya->setEnabled(FALSE);
 }
 sonf->setTip(tip);
 if (sayfa2s->currentTab()==sayfa2x[0]->id)
  apt=tip;
 if (sayfa2s->currentTab()==sayfa2x[1]->id)
  ppt=tip;
 if (sayfa2s->currentTab()==sayfa2x[2]->id)
  mut=tip;
}

void AnaPencere::SayfaDegis(int sayfa)
{
 int say;
 for (say=0;say<sayfa_say;say++)
  if (sayfa==sayfax[say]->id)
   sayfaxf[say]->show();
  else
   sayfaxf[say]->hide();
}

void AnaPencere::SayfaDegis2(int sayfa)
{
 int say1,say2;
 if (sayfa==sayfa2x[0]->id)
 {
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
    renkler[say1][say2]->setValue(apr[say1][say2]);
  sec_renktipi->setButton(apt);
  TipDegis(apt);
  edit_boyadosya->setText(apd_isim);
 }
 if (sayfa==sayfa2x[1]->id)
 {
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
    renkler[say1][say2]->setValue(ppr[say1][say2]);
  sec_renktipi->setButton(ppt);  
  TipDegis(ppt);
  edit_boyadosya->setText(ppd_isim);
 }
 if (sayfa==sayfa2x[2]->id)
 {
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
    renkler[say1][say2]->setValue(mur[say1][say2]);
  sec_renktipi->setButton(mut);  
  TipDegis(mut);
  edit_boyadosya->setText(mud_isim);
 }
}

void AnaPencere::RenkDegis(int renk)
{
 int say1,say2,say1a=-1,say2a;
 for (say1=0;say1<2;say1++)
  for (say2=0;say2<3;say2++)
   if ((QSpinBox *)sender()==renkler[say1][say2])
   {
    say1a=say1;
    say2a=say2;
   }
 if (say1a<0)
  return;
 switch (say2a)
 {
  case 0:
   renkf[say1a][0]->setRgb(renk,0,0,0);
   break;
  case 1:
   renkf[say1a][1]->setRgb(0,renk,0,0);
   break;
  case 2:
   renkf[say1a][2]->setRgb(0,0,renk,0);
   break;
 }
 renkf[say1a][3]->setRgb(renkf[say1a][0]->r1,renkf[say1a][1]->g1,renkf[say1a][2]->b1,0);
 sonf->setRgb(renkf[say1a][0]->r1,renkf[say1a][1]->g1,renkf[say1a][2]->b1,say1a);
 if (sayfa2s->currentTab()==sayfa2x[0]->id)
  apr[say1a][say2a]=renk;
 if (sayfa2s->currentTab()==sayfa2x[1]->id)
  ppr[say1a][say2a]=renk;
 if (sayfa2s->currentTab()==sayfa2x[2]->id)
  mur[say1a][say2a]=renk;
}

void AnaPencere::verileri_yukle()
{
 XrmDatabase veriler;
 char dosya_adi[255],*deger_tipi,veri_adi[255];
 XrmValue deger_veri;
 int say1,say2;
 // Veri tabani icin standart ayarlari yukle...
 apt=
 apr[0][0]=apr[0][1]=
 apr[1][0]=apr[1][1]=apr[1][2]=0;
 apr[0][2]=255;
 ppt=
 ppr[1][0]=ppr[1][1]=ppr[1][2]=0;
 ppr[0][0]=ppr[0][1]=ppr[0][2]=127;
 mur[0][0]=mur[0][1]=
 mur[1][0]=mur[1][1]=mur[1][2]=0;
 mut=1;
 mur[0][2]=255;
 cift_klik=250;
 menu_boyut_h=16;
 uzaktan_durum=0;
 strcpy(uzaktan_sifre,"efsane");
 apd_isim[0]=ppd_isim[0]=mud_isim[0]=0;
 // Veri tabanini baslat...
 XrmInitialize();
 // Dosyayi ac...
 sprintf(dosya_adi,"%s/.efsane.ayarlar",getenv("HOME"));
 if ((veriler=XrmGetFileDatabase(dosya_adi))!=NULL)
 {
  // Dili tipini al...
  XrmGetResource(veriler,"efsane.dil","efsane.dil",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&dil_isim);
  // Bilgi tipini al...
  XrmGetResource(veriler,"bilgi.goster","bilgi.goster",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&bilgi_goster);
  // Menu boyutunu al...
  XrmGetResource(veriler,"menu.yukseklik","menu.yukseklik",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&menu_boyut_h);
  // Cift klikleme suresini al...
  XrmGetResource(veriler,"cift","cift",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&cift_klik);
  // Aktif Pencere boyama Tipini al...
  XrmGetResource(veriler,"apt","apt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&apt);
  // Pasif Pencere boyama Tipini al...
  XrmGetResource(veriler,"ppt","ppt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&ppt);
  // Masa Ustu boyama Tipini al...
  XrmGetResource(veriler,"mut","mut",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&mut);
  // Aktif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"apd.isim","apd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&apd_isim);
  // Pasif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"ppd.isim","ppd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&ppd_isim);
  // Masa Ustu boyama Dosya Ismini al...
  XrmGetResource(veriler,"mud.isim","mud.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&mud_isim);
  // Uzaktan Kumanda durumunu al...
  XrmGetResource(veriler,"uzaktan.durum","uzaktan.durum",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&uzaktan_durum);
  // Uzaktan Kumanda sifresini al...
  XrmGetResource(veriler,"uzaktan.sifre","uzaktan.sifre",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",uzaktan_sifre);
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
   {
    // Aktif Pencere boyama Rengini al...
    sprintf(veri_adi,"apr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&apr[say1][say2]);
    // Pasif Pencere boyama Rengini al...
    sprintf(veri_adi,"ppr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&ppr[say1][say2]);
    // Masa Ustu boyama Rengini al...
    sprintf(veri_adi,"mur%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&mur[say1][say2]);
   }
  // Veri tabanini kapat...
  XrmDestroyDatabase(veriler);
 }
}

void AnaPencere::verileri_goruntule()
{
 edit_menuyukseklik->setValue(menu_boyut_h);
 edit_cift->setValue(cift_klik);
 edit_uzakdurum->setChecked(uzaktan_durum);
 edit_bilgidurum->setChecked(bilgi_goster);
 edit_uzaksifre->setText(uzaktan_sifre);
 for (int say=0;say<3;say++)
  if (!strcmp(dil_yazi[say],dil_isim))
   edit_dilsec->setCurrentItem(say);
}




BoyaKutu::BoyaKutu(QWidget *parent,int t) : QFrame(parent,"")
{
 ren=new QColor();
 dosya=new QString();
 resim=new QImage();
 pxmp=new QPixmap();
 nokta=new uint;
 tip=t;
 setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
}

BoyaKutu::~BoyaKutu()
{
 delete ren;
 delete dosya;
 delete resim;
 delete pxmp;
 delete nokta;
}

void BoyaKutu::setStr(const char *isim)
{
 dosya->setStr(isim);
 update();
}

void BoyaKutu::setRgb(int rr,int gg,int bb,int no)
{
 switch (no)
 {
  case 0:
   r1=rr;g1=gg;b1=bb;
   break;
  case 1:
   r2=rr;g2=gg;b2=bb;
   break;
 }
 update();
}

void BoyaKutu::drawContents(QPainter *pnt)
{
 int h,y;
 float artk,arty,artm,kk,yy,mm;
 switch (tip)
 {
  case 0:
   ren->setRgb(r1,g1,b1);
   pnt->setBrush(*ren);
   pnt->fillRect(contentsRect(),pnt->brush());
   break;
  case 1:
   resim->create(1,h=contentsRect().height(),32);
   artk=(float)(r2-r1)/h;arty=(float)(g2-g1)/h;artm=(float)(b2-b1)/h;kk=r1;yy=g1;mm=b1;
   for (y=0;y<h;y++)
   {
    nokta=(uint *)resim->scanLine(y);
    *nokta=qRgb((int)kk,(int)yy,(int)mm);
    kk+=artk;yy+=arty;mm+=artm;
   }
   pxmp->convertFromImage(*resim);
   pnt->drawTiledPixmap(contentsRect(),*pxmp);
   break;
  case 2:
   resim->load(*dosya,0);
   pxmp->convertFromImage(*resim);
   pnt->drawTiledPixmap(contentsRect(),*pxmp);
   break;
 }
}

void BoyaKutu::setTip(int t)
{
 tip=t;
 update();
}
