/**************************\
*  Efsane 0.5.11           *
*  Uzaktan Kumanda Modulu  *
\**************************/

#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <sys/socket.h>

#define baglanti_portu 8888
#define infostr "\nEfsane 0.3\nUzaktan Kumanda Modulu\nSurum: Beta.1\n\n"
#define infostr2 "\nYardim icin ? komutunu veriniz.\n"
#define infolen 50
#define infolen2 33
#define scr DefaultScreen(dpy)

int soket,soket2,sizeof_sockaddr_in=sizeof(struct sockaddr_in);
struct sockaddr_in soket_adres,baglan_adres;
Window pencere;
Display *dpy;
char **komut,uzaktan_sifre[80];

void kapat(int soket)
{
 // Soketi kapat...
 shutdown(soket,2);
}

void basla(void)
{
 // Komut degiskenine yer ayarla...
 komut=(char **) malloc(sizeof(char *)*2);
 komut[0]=(char *) malloc(20);
 komut[1]=(char *) malloc(20);
 // Soketi yarat...
 if ((soket=socket(AF_INET,SOCK_STREAM,0))<0)
 {
  kapat(soket);
  exit(0);
 }
 // Sokete adres ve port ayarla...
 soket_adres.sin_family=AF_INET;
 soket_adres.sin_port=htons(baglanti_portu);
 soket_adres.sin_addr.s_addr=INADDR_ANY;
 bzero(&(soket_adres.sin_zero),8);
 if (bind(soket,(struct sockaddr *)&soket_adres,sizeof(struct sockaddr))<0)
 {
  kapat(soket);
  exit(0);
 }
 // Soketi baglantiya ac...
 if (listen(soket,1)<0)
 {
  kapat(soket);
  exit(0);
 }
}

Bool cevap_bekle(void)
{
 Bool devam=True;
 XEvent olay;
 char **argv,yaz[255];
 int argc,say;
 while (devam)
 {
  XNextEvent(dpy,&olay);
  if (olay.type==PropertyNotify && olay.xproperty.state!=PropertyDelete &&
      olay.xproperty.atom==XA_WM_COMMAND && olay.xproperty.window==pencere)
  {
   XGetCommand(dpy,pencere,&argv,&argc);
   if (argc>1)
    for (say=0;say<argc-1;say++)
    {
     sprintf(yaz,"\n%s",argv[say]);
     if (send(soket2,yaz,strlen(yaz),0)<0) return False;
    }
   devam=False;
  }
 }
 if (!strcmp(argv[argc-1],"tamam"))
  return True;
 else
  return False;
}

void baglan()
{
 XEvent olay2;
 int okunan,yanlis=0;
 char sifre[64];
 if (send(soket2,infostr,infolen,0)<0) return;
 do
 {
  if (send(soket2,"Sifrenizi giriniz: ",19,0)<0) return;
  if ((okunan=recv(soket2,sifre,64,0))<0) return;
  sifre[okunan-2]=0;
  if (okunan=strcmp(sifre,uzaktan_sifre))
  {
   if (++yanlis>2)
   {
    send(soket2,"Yanlis sifre! Baglanti kesilmistir!\n\n",37,0);
    return;
   }
   sprintf(sifre,"Yanlis sifre! %d hakkiniz kaldi!\n\n",3-yanlis);
   if (send(soket2,sifre,strlen(sifre),0)<0) return;
  }
 }
 while (okunan);
 if (send(soket2,infostr2,infolen2,0)<0) return;
 while (True)
 {
  if (send(soket2,"\nKomut> ",8,0)<0) return;
  if ((okunan=recv(soket2,sifre,64,0))<0) return;
  if (okunan<3) continue;
  sifre[okunan-2]=0;
  if (!strcmp(sifre,"cik") || !strcmp(sifre,"cikis"))
  {
   kapat(soket2);
   kapat(soket);
   exit(0);
  }
  else
  if (!strcmp(sifre,"kapat")) return;
  else
  if (!strcmp(sifre,"yardim") || !strcmp(sifre,"imdat") || !strcmp(sifre,"?"))
  {
   if (send(soket2,"\ncalis : Program calistirir.",28,0)<0) return;
   if (send(soket2,"\nliste : Pencere listesini alir.",32,0)<0) return;
   if (send(soket2,"\noz_al : Pencerelerden istenenin ozelliklerini alir.",52,0)<0) return;
   if (send(soket2,"\nozver : Pencerelerden istenenin ozelliklerini degistirir.",58,0)<0) return;
   if (send(soket2,"\nsonla : Pencerelerden isteneni kapatir.",40,0)<0) return;
   if (send(soket2,"\noldur : Pencerelerden isteneni oldurur.",40,0)<0) return;
   if (send(soket2,"\ncikis : Uzaktan Kumanda Modulu'nu kapatir.",43,0)<0) return;
   if (send(soket2,"\nkapat : Baglantiyi kapatir.",28,0)<0) return;
  }
  else
  {
   if (send(soket2,"\nX ile baglanti kuruluyor...\n",29,0)<0) return;
   XStoreName(dpy,pencere,sifre);
   XFlush(dpy);
   if (cevap_bekle())
   {
    if (send(soket2,"\nIslem basariyla tamamlandi.",28,0)<0) return;
   }
   else
    if (send(soket2,"\nBir hata olustu.",17,0)<0) return;
  }
  if (send(soket2,"\n",1,0)<0) return;
 }
}

void X_baglan(int argc,char **argv)
{
 if (argc!=3)
 {
  printf("Hata: Bu program sadece Efsane tarafindan calistirilabilir.\n\n");
  exit(1);
 }
 dpy=XOpenDisplay(NULL);
 if (!dpy)
 {
  printf("Hata: Bu program sadece Efsane tarafindan calistirilabilir.\n\n");
  exit(1);
 }
 sscanf(argv[1]," %ld",&pencere);
 XSelectInput(dpy,pencere,PropertyChangeMask);
 sscanf(argv[2]," %s",uzaktan_sifre);
}

int main(int argc,char **argv)
{
 X_baglan(argc,argv);
 basla();
 while (True)
 {
  if ((soket2=accept(soket,(sockaddr *)&baglan_adres,(socklen_t *)&sizeof_sockaddr_in))>=0)
   baglan();
  kapat(soket2);
 }
}

