/***************************\
*  Efsane Yoneticisi 0.6.0  *
*  Sistem Modulu            *
*  Baslik (.h) Dosyasi      *
\***************************/

#include <qmainwindow.h>
#include <qmenubar.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qtabbar.h>
#include <qframe.h>
#include <qbuttongroup.h>
#include <qcombobox.h>
#include <qradiobutton.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qimage.h>

#define sayfa_say 3
#define tuslar_say 2

class BoyaKutu;

class AnaPencere : public QMainWindow
{
	Q_OBJECT
public:
	AnaPencere(void);
	QFrame *(sayfaxf[sayfa_say]);
	BoyaKutu *(renkf[2][4]),*sonf;
	QTabBar *sayf,*sayfa2s;
	QTab *(sayfax[sayfa_say]),*(sayfa2x[3]);
	QSpinBox *edit_menuyukseklik,*edit_cift,*(renkler[2][3]);
	QCheckBox *edit_uzakdurum,*edit_bilgidurum;
	QLineEdit *edit_uzaksifre,*edit_boyadosya;
        QComboBox *edit_dilsec;
	QButtonGroup *sec_renktipi;
	QPushButton *tus_boyadosya,*(tuslar[tuslar_say]);
	QGroupBox *(sec_renk[2]);
	QRadioButton *(tus_renktipi[3]);
private:
	void verileri_yukle(void);
	void verileri_goruntule(void);
private slots:
	void SayfaDegis(int);
	void SayfaDegis2(int);
	void RenkDegis(int);
	void TipDegis(int);
	void DosyaSec(void);
	void verileri_kaydet(void);
};

class BoyaKutu : public QFrame
{
	Q_OBJECT
public:
	BoyaKutu(QWidget *,int);
	~BoyaKutu(void);
	void setRgb(int,int,int,int);
	void setTip(int);
	int r1,g1,b1,r2,g2,b2,tip;
public slots:
	void setStr(const char *);
private:
	QString *dosya;
	QImage *resim;
	QColor *ren;
	QPixmap *pxmp;
	uint *nokta;
protected:
	void drawContents(QPainter *);
};

